diff --git a/plugins/percol/README.md b/plugins/percol/README.md
index ec5de4f86..78c881f55 100644
--- a/plugins/percol/README.md
+++ b/plugins/percol/README.md
@@ -1,20 +1,23 @@
-## percol
+# percol
-Provides some useful function to make [percol](https://github.com/mooz/percol) work with zsh history and [jump plugin](https://github.com/ohmyzsh/ohmyzsh/blob/master/plugins/jump/jump.plugin.zsh)
+Provides some useful function to make [percol](https://github.com/mooz/percol) work with zsh history and
+the [jump plugin](https://github.com/ohmyzsh/ohmyzsh/tree/master/plugins/jump), optionally.
-### Requirements
+To use it, add `percol` to the plugins array in your zshrc:
-```shell
-pip install percol
+```zsh
+plugins=(... percol)
```
-And [jump](https://github.com/ohmyzsh/ohmyzsh/blob/master/plugins/jump/jump.plugin.zsh) for `oh-my-zsh` is a optional requirement.
+## Requirements
-### Usage
+- `percol`: install with `pip install percol`.
-For default
+- (_Optional_) [`jump`](https://github.com/ohmyzsh/ohmyzsh/tree/master/plugins/jump) plugin: needs to be
+ enabled before the `percol` plugin.
-- `^-r` bind to `percol_select_history`.You can use it to grep your history with percol.
+## Usage
-- `^-b` bind to `percol_select_marks`.You can use it to grep your bookmarks with percol.
+- CTRL-R (bound to `percol_select_history`): you can use it to grep your history with percol.
+- CTRL-B (bound to `percol_select_marks`): you can use it to grep your jump bookmarks with percol.
diff --git a/plugins/percol/percol.plugin.zsh b/plugins/percol/percol.plugin.zsh
index c6adf4e1e..b78383eee 100644
--- a/plugins/percol/percol.plugin.zsh
+++ b/plugins/percol/percol.plugin.zsh
@@ -1,22 +1,25 @@
-if which percol &> /dev/null; then
- function percol_select_history() {
- local tac
- which gtac &> /dev/null && tac="gtac" || { which tac &> /dev/null && tac="tac" || { tac="tail -r" } }
- BUFFER=$(fc -l -n 1 | eval $tac | percol --query "$LBUFFER")
- CURSOR=$#BUFFER
- zle -R -c
- }
+(( ${+commands[percol]} )) || return
- zle -N percol_select_history
- bindkey '^R' percol_select_history
+function percol_select_history() {
+ # print history in reverse order (from -1 (latest) to 1 (oldest))
+ BUFFER=$(fc -l -n -1 1 | percol --query "$LBUFFER")
+ CURSOR=$#BUFFER
+ zle -R -c
+}
+zle -N percol_select_history
+bindkey -M emacs '^R' percol_select_history
+bindkey -M viins '^R' percol_select_history
+bindkey -M vicmd '^R' percol_select_history
- if which marks &> /dev/null; then
- function percol_select_marks() {
- BUFFER=$(marks | percol --query "$LBUFFER" | awk '{print $3}')
- CURSOR=$#BUFFER # move cursor
- zle -R -c # refresh
- }
- zle -N percol_select_marks
- bindkey '^B' percol_select_marks
- fi
+if (( ${+functions[marks]} )); then
+ function percol_select_marks() {
+ # parse directory from marks output (markname -> path) and quote if necessary
+ BUFFER=${(q)"$(marks | percol --query "$LBUFFER")"##*-> }
+ CURSOR=$#BUFFER
+ zle -R -c
+ }
+ zle -N percol_select_marks
+ bindkey -M emacs '^B' percol_select_marks
+ bindkey -M viins '^B' percol_select_marks
+ bindkey -M vicmd '^B' percol_select_marks
fi